﻿using System.IO;

namespace uqac_ia_sudoku_csp.Solver.Generators
{
    public class FileGeneratorDbo
    {
        public string FilePath { get; set; }

        public string EmptyCharacters { get; set; }
    }

    public class FileGenerator : TextReaderGenerator
    {
        public override void Generate(Board board, object data)
        {
            var dbo = data as FileGeneratorDbo;
            using (var stream = File.OpenText(dbo.FilePath))
            {
                base.Generate(board, new TextReaderGeneratorDbo
                {
                    EmptyCharacters = dbo.EmptyCharacters,
                    Reader = stream
                });
            }
        }
    }
}